/**
* 
* Copyright (C) 2004-2008 FhG Fokus
*
* This file is part of the FhG Fokus UPnP stack - an open source UPnP implementation
* with some additional features
*
* You can redistribute the FhG Fokus UPnP stack and/or modify it
* under the terms of the GNU General Public License Version 3 as published by
* the Free Software Foundation.
*
* For a license to use the FhG Fokus UPnP stack software under conditions
* other than those described here, or to purchase support for this
* software, please contact Fraunhofer FOKUS by e-mail at the following
* addresses:
*   upnpstack@fokus.fraunhofer.de
*
* The FhG Fokus UPnP stack is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, see <http://www.gnu.org/licenses/>
* or write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*/
package de.fraunhofer.fokus.upnp.core.examples.gui_control_point.plugins;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JPanel;

import de.fraunhofer.fokus.upnp.core.DeviceConstant;
import de.fraunhofer.fokus.upnp.core.control_point.AttributeParser;
import de.fraunhofer.fokus.upnp.core.control_point.CPAction;
import de.fraunhofer.fokus.upnp.util.exceptions.ActionFailedException;
import de.fraunhofer.fokus.upnp.util.swing.ButtonConstants;
import de.fraunhofer.fokus.upnp.util.swing.SmoothValueButton;

/**
 * This plugin is used for attribute services.
 * 
 * @author Alexander Koenig
 */
public class AttributeServicePlugin extends BaseCPServicePlugin
{

  private static final long serialVersionUID         = 1L;

  public static String      PLUGIN_TYPE              = DeviceConstant.ATTRIBUTE_SERVICE_TYPE;

  private Vector            attributeValueButtonList = new Vector();

  /** Retrieves the type of the plugin */
  public String getPluginType()
  {
    return PLUGIN_TYPE;
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.fhg.fokus.magic.upnp.examples.gui_control_point.plugins.BasePlugin#initPluginComponents()
   */
  public void initPluginComponents()
  {
    super.initPluginComponents();
    initComponents();

    setBackground(ButtonConstants.BACKGROUND_COLOR);
    // initialize panel layout
    updateLayout();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.fhg.fokus.magic.upnp.control_point.plugins.BasePlugin#runPlugin()
   */
  public void startPlugin()
  {
    super.startPlugin();

    Thread thread = new Thread(this);
    thread.setName("AttributeServicePlugin");
    thread.start();
  }

  /** Collect all attributes. */
  public void run()
  {
    CPAction action = service.getCPAction("GetAttributeList");
    if (action != null)
    {
      try
      {
        controlPoint.invokeAction(action);

        String attributeList = action.getArgument("Result").getStringValue();

        AttributeParser attributeParser = new AttributeParser();
        attributeParser.parse(attributeList);

        Enumeration names = attributeParser.getAttributeTable().keys();

        while (names.hasMoreElements())
        {
          String name = (String)names.nextElement();
          String value = (String)attributeParser.getAttributeTable().get(name);
          SmoothValueButton smoothValueButton =
            new SmoothValueButton(new Dimension(300, ButtonConstants.BUTTON_HEIGHT), 12, name, value, null);

          smoothValueButton.setSelectable(false);
          smoothValueButton.setDisabledButtonColor(smoothValueButton.getButtonColor());
          // try to translate both property and value
          deviceGUIContextProvider.getDeviceContext(service)
            .getDeviceTranslations()
            .setTranslationForButton(smoothValueButton, smoothValueButton.getText(), "", ":");
          deviceGUIContextProvider.getDeviceContext(service)
            .getDeviceTranslations()
            .setTranslationForButtonValue(smoothValueButton, smoothValueButton.getValue(), "", "");

          attributeValueButtonList.add(smoothValueButton);
        }

      } catch (ActionFailedException afe)
      {
        System.out.println("An error occured:" + afe.getMessage());
      } catch (Exception ex)
      {
        System.out.println("An error occured:" + ex.getMessage());
      }
    }
    updateLayout();
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT
   * modify this code. The content of this method is always regenerated by the Form Editor.
   */
  private void initComponents()// GEN-BEGIN:initComponents
  {

    setLayout(new java.awt.GridBagLayout());

    setBackground(new java.awt.Color(204, 204, 255));
  }// GEN-END:initComponents

  /** Redraws the layout of the plugin */
  private void updateLayout()
  {
    removeAll();
    GridBagConstraints gridBagConstraints;

    int propertyCount = attributeValueButtonList.size();

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridheight = propertyCount + 2;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.weighty = 1.0;
    gridBagConstraints.fill = GridBagConstraints.BOTH;
    JPanel leftFillPanel = new JPanel();
    leftFillPanel.setBackground(ButtonConstants.BACKGROUND_COLOR);
    add(leftFillPanel, gridBagConstraints);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 2;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridheight = propertyCount + 2;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.weighty = 1.0;
    gridBagConstraints.fill = GridBagConstraints.BOTH;
    JPanel rightFillPanel = new JPanel();
    rightFillPanel.setBackground(ButtonConstants.BACKGROUND_COLOR);
    add(rightFillPanel, gridBagConstraints);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridwidth = 1;
    gridBagConstraints.weighty = 1.0;
    gridBagConstraints.fill = GridBagConstraints.BOTH;
    JPanel topFillPanel = new JPanel();
    topFillPanel.setBackground(ButtonConstants.BACKGROUND_COLOR);
    add(topFillPanel, gridBagConstraints);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = propertyCount + 1;
    gridBagConstraints.gridwidth = 1;
    gridBagConstraints.weighty = 1.0;
    gridBagConstraints.fill = GridBagConstraints.BOTH;
    JPanel bottomFillPanel = new JPanel();
    bottomFillPanel.setBackground(ButtonConstants.BACKGROUND_COLOR);
    add(bottomFillPanel, gridBagConstraints);

    for (int i = 0; i < attributeValueButtonList.size(); i++)
    {
      gridBagConstraints = new GridBagConstraints();
      gridBagConstraints.gridx = 1;
      gridBagConstraints.gridy = i + 1;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
      gridBagConstraints.insets = new Insets(2, 5, 2, 5);

      add((SmoothValueButton)attributeValueButtonList.elementAt(i), gridBagConstraints);
    }

    repaint();
    validateTree();
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables

}
